<?php
/*
 * $Id: progress_tracker.inc.php,v 1.1 2006/05/21 23:29:39 shida Exp $
 * 
 * License:  GNU General Public License
 *
 * Copyright (c) 2006 in3c.org
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 * 
 */

require_once PLUGIN_DIR . "show_er.inc.php";

function plugin_show_dbtable_convert()
{
    list($table_name, $db_configure_file_name) = func_get_args();

    if (empty($table_name)) {
        return "<div>show_dbtable error: table name is empty</div>";
    }

    $tableViewer = new PukiWiki_Plugin_DB($db_configure_file_name);
    $result = $tableViewer->init();

    if (PEAR::isError($result)) {
        return "<div>" . $result->getMessage() . "</div>";
    }

    $db = $tableViewer->connect($tableViewer->getDsn());        
    if (PEAR::isError($db)) {
        return "<div>" . getMessage() . "</div>";
    }

    $result = get_table_info_html($db, $table_name);
    if (PEAR::isError($result)) {
        return "<div>" . getMessage() . "</div>";
    }
    
    return $result;
}


function get_table_info_html($db, $table_name) {

    $res =& $db->query("SHOW FULL COLUMNS FROM $table_name");
    if (PEAR::isError($res)) {
        return $res;
    }
    
    $buf = "ơ֥̾: $table_name\n";

    $column_titles = array('Field',
                           'Type',
                           'Null',
                           'Key',
                           'Default',
                           'Extra',
                           'Comment');

    $buf .= "|";
    foreach ($column_titles as $title) {
        $buf .= $title . "|";
    }
    $buf .= "h\n";

    while ($res->fetchInto($row)) {
        $buf .= "|";
        foreach (array(0,1,3,4,5,6,8) as $idx) {
            $buf .= $row[$idx] . "|";
        }
        $buf .= "\n";
    }
    
    return convert_html($buf);
}

?>
